#include <stdlib.h>

#include "deque.h"

void deque_init(deque_t* dq, int q_size, int data_size) {
  int i;

  dq->m_QUEUE_SIZE = q_size;
  dq->m_right = dq->m_QUEUE_SIZE / 2;
  dq->m_left = dq->m_right - 1;
  dq->m_elems = (int*) malloc(dq->m_QUEUE_SIZE * sizeof(int));

  dq->m_DATA_SIZE = data_size;
  dq->m_data = (int*) malloc(dq->m_DATA_SIZE * sizeof(int));
  for (i = 0; i < dq->m_DATA_SIZE; i++) {
    dq->m_data[i] = rand();
  }
}

void deque_destroy(deque_t* dq) {
  free(dq->m_elems);
  free(dq->m_data);
}

int enqueueLeft(deque_t* dq, int elem) {
  dq_doWork(dq);
  if (dq->m_left < 0) {
    return 0;
  }
  dq->m_elems[dq->m_left--] = elem;
  return 1;
}

int enqueueRight(deque_t* dq, int elem) {
  dq_doWork(dq);
  if (dq->m_right >= dq->m_QUEUE_SIZE) {
    return 0;
  }
  dq->m_elems[dq->m_right++] = elem;
  return 1;
}

int dequeueLeft(deque_t* dq, int* elem) {
  dq_doWork(dq);
  if (dq->m_left >= dq->m_right - 1) {
    elem = NULL;
    return 0;
  }
  *elem = dq->m_elems[dq->m_left++ + 1];
  return 1;
}

int dequeueRight(deque_t* dq, int* elem) {
  dq_doWork(dq);
  if (dq->m_right <= dq->m_left + 1) {
    elem = NULL;
    return 0;
  }
  *elem = dq->m_elems[dq->m_right-- - 1];
  return 1;
}

void dq_doWork(deque_t* dq) {
  int i, total = 0;
  for (i = 0; i < dq->m_DATA_SIZE; i++) {
    total += dq->m_data[i];
  }
}
