#ifndef _DEQUE_H_
#define _DEQUE_H_

typedef struct {
  int m_QUEUE_SIZE;
  int m_DATA_SIZE;

  // the next free index
  // full if -1 and m_QUEUE_SIZE, respectively
  int m_left; // -1 <= m_left < m_right
  int m_right; // m_left < m_right <= m_QUEUE_SIZE

  int* m_elems;
  int* m_data;
} deque_t;

// must do srand elsewhere if desired for constructors
void deque_init(deque_t* dq, int qSize, int dataSize);
void deque_destroy(deque_t* dq);

// return true if successful: there was room
int enqueueLeft(deque_t* dq, int elem);
int enqueueRight(deque_t* dq, int elem);
int dequeueLeft(deque_t* dq, int* elem);
int dequeueRight(deque_t* dq, int* elem);
void dq_doWork(deque_t* dq);

#endif
