#include <stdlib.h>
//#include <iostream.h>

#include "Deque.h"

template<class T>
Deque<T>::Deque() {
  m_QUEUE_SIZE = Deque<T>::DEFAULT_QUEUE_SIZE;
  m_right = m_QUEUE_SIZE / 2;
  m_left = m_right - 1;
  m_elems = new T[m_QUEUE_SIZE];

  m_DATA_SIZE = Deque<T>::DEFAULT_DATA_SIZE;
  m_data = new int[m_DATA_SIZE];
  for (int i = 0; i < m_DATA_SIZE; i++) {
    m_data[i] = rand();
  }
}

template<class T>
Deque<T>::Deque(int qSize, int dataSize) {
  m_QUEUE_SIZE = qSize;
  m_right = m_QUEUE_SIZE / 2;
  m_left = m_right - 1;
  m_elems = new T[m_QUEUE_SIZE];

  m_DATA_SIZE = dataSize;
  m_data = new int[m_DATA_SIZE];
  for (int i = 0; i < m_DATA_SIZE; i++) {
    m_data[i] = rand();
  }
}

template<class T>
Deque<T>::~Deque() {
  delete[] m_elems;
  delete[] m_data;
}

template<class T>
int const * Deque<T>::getData() {
  return m_data;
}

template<class T>
int Deque<T>::getDataSize() {
  return m_DATA_SIZE;
}

template<class T>
int Deque<T>::getLeft() {
  return m_left;
}

template<class T>
int Deque<T>::getRight() {
  return m_right;
}

template<class T>
int Deque<T>::getSize() {
  return m_QUEUE_SIZE;
}

template<class T>
bool Deque<T>::enqueueLeft(T elem) {
  doWork();
  if (m_left < 0) {
    return false;
  }
  m_elems[m_left--] = elem;
  return true;
}

template<class T>
bool Deque<T>::enqueueRight(T elem) {
  doWork();
  if (m_right >= m_QUEUE_SIZE) {
    return false;
  }
  m_elems[m_right++] = elem;
  return true;
}

template<class T>
bool Deque<T>::dequeueLeft(T* elem) {
  doWork();
  if (m_left >= m_right - 1) {
    elem = NULL;
    return false;
  }
  *elem = m_elems[m_left++ + 1];
  return true;
}

template<class T>
bool Deque<T>::dequeueRight(T* elem) {
  doWork();
  if (m_right <= m_left + 1) {
    elem = NULL;
    return false;
  }
  *elem = m_elems[m_right-- - 1];
  return true;
}

template<class T>
void Deque<T>::doWork() {
  int total = 0;
  for (int i = 0; i < m_DATA_SIZE; i++) {
    total += m_data[i];
  }
}

template class Deque<int>;
