#ifndef _DEQUE_H_
#define _DEQUE_H_

template<class T>
class Deque {

public:
  static int const DEFAULT_QUEUE_SIZE = 1024;
  static int const DEFAULT_DATA_SIZE = 512;

  // must do srand elsewhere if desired for constructors
  Deque();
  Deque(int qSize, int dataSize);
  ~Deque();

  int const * getData();
  int getDataSize();
  int getLeft();
  int getRight();
  int getSize();

  // return true if successful: there was room
  bool enqueueLeft(T elem);
  bool enqueueRight(T elem);
  bool dequeueLeft(T* elem);
  bool dequeueRight(T* elem);
  void doWork();

private:
  int m_QUEUE_SIZE;
  int m_DATA_SIZE;

  // the next free index
  // full if -1 and m_QUEUE_SIZE, respectively
  int m_left; // -1 <= m_left < m_right
  int m_right; // m_left < m_right <= m_QUEUE_SIZE

  T* m_elems;
  int* m_data;
};

#endif
