#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

/* CAS macro
   semantics:
   If (a == b) then a = c
   c = OLD VALUE OF a
*/
#define CAS(a,b,c)   \
asm volatile(                           \
  "mov %1,%%l2\n"        \
  "mov %2,%%l1\n"        \
  "mov %0,%%l3\n"        \
  "cas [%%l2],%%l1,%%l3\n" \
  "mov %%l3,%3\n"    \
  :"=r"(c) \
  : "r"(&a), "r"(b),"r"(c)       \
  :"l1","l2","l3"                        \
);

int count = -1;

void * slave(void *t){
  int real_id = (int) t;
  int myid;
  int inc_count;
  int i;
  
  for (i = 0; i < 1; i++)
  {
    while (1){
      printf("try\n");
      /* Get the value of the global variable */
      myid = count;
      inc_count = myid + 1;
      sleep (1);
      /* Try to write the incremented value into the global variable.
         This
         will succeed only if the global variable was not overwritten
         in
         the meanwhile by another thread */
      CAS(count, myid, inc_count);
      if (myid == inc_count)
        /* CAS succeeded */
        break;
    }
  }
  
  return (NULL);
}

int main(int argc, char **argv){
    pthread_t *threads;
    pthread_attr_t pthread_custom_attr;
    int num_threads;
    int i;
        
    if (argc != 2){
        printf("Usage: %s <num_threads>\n",argv[0]);
        exit(1);
    }
        
    num_threads = atoi(argv[1]);
    threads = (pthread_t *)calloc(num_threads,sizeof(pthread_t));
    pthread_attr_init(&pthread_custom_attr);

    for ( i = 0; i < num_threads; i++){
        pthread_create(&threads[i], &pthread_custom_attr, slave, NULL);
    }

    for ( i = 0; i < num_threads; i++){
        pthread_join(threads[i],NULL);
    }

    printf("count=%d\n", count);

    return 0;
}        
                                
